]> oss.titaniummirror.com Git - repo_shell.git/blobdiff - scripts/gitcreate
gitcreate: Differentiate repopath and repodir
[repo_shell.git] / scripts / gitcreate
index 7a46d1b0ab6e0b62652339e9ba4fc6da27e46dea..3c7cd36a447b7bee5ab0ef0207e14b88dece1650 100755 (executable)
@@ -1,9 +1,10 @@
 #!/bin/sh
 # gitcreate is part of the repo_shell distribution.
 
-eval $(sed -e 's| ||g' < /etc/repo_shell.conf)
+eval $([ -f /etc/repo_shell.conf ] && sed -e 's| ||g' < /etc/repo_shell.conf)
 if [ -z "$owner" -o -z "$git_root" ]; then
     echo "$0: please configure /etc/repo_shell.conf"
+    exit 1
 fi
 gitacls="$git_root/.gitacls"
 
@@ -12,37 +13,46 @@ if [ "$(whoami)" != "$owner" ]; then
     exit 1
 fi
 
+unset yes
+if [ "$1" = "-y" ]; then
+  yes=y
+  shift
+fi
+
 if [ $# -ne 1 ]; then
     echo "usage: $0 <repopath>" >&2
     exit 1
 fi
 
-if [ -e $git_root/$1 ]; then
-    echo "$0: repository $1 already exists" >&2
+repopath=$1
+
+if [ -e $git_root/$repopath ]; then
+    echo "$0: repository $repopath already exists" >&2
     exit 1
 fi
 
 # Do not create subdirectories without asking first
-repopath=$(dirname $1)
-if [ ! -d "$git_root/$repopath" ]; then
-  echo -n "Create git subdir '$repopath' (y/N)? "
-  read ans
-  if [ "$ans" = "y" -o "$ans" = "Y" -o "$ans" = "yes" -o "$ans" = "Yes" \
-      -o "$ans" = "YES" ];then
-    mkdir -p "$git_root/$repopath" 2>/dev/null
-    if [ ! -d "$git_root/$repopath" ]; then
-      echo "%0: repository not created, git subdir '$repopath' create failed" >&2
-      exit 1
+repodir=$(dirname $repopath)
+if [ ! -d "$git_root/$repodir" ]; then
+  if [ ! $yes ]; then
+    echo -n "Create git subdir '$repodir' (y/N)? "
+    read ans
+    ans=$(expr "$ans" : '\(.\).*') # works with dash too
+    if [ "$ans" != "y" -a "$ans" != "Y" ];then
+      echo "repository creation aborted at user request"
+      exit 0
     fi
-  else
-    echo "repository creation aborted at user request"
-    exit 0
+  fi
+  mkdir -p "$git_root/$repodir" 2>/dev/null
+  if [ ! -d "$git_root/$repodir" ]; then
+    echo "%0: repository not created, git subdir '$repodir' create failed" >&2
+    exit 1
   fi
 fi
 
 # Create the respository
 umask 027
-git --git-dir "$git_root/$1" init --bare
+git --git-dir "$git_root/$repopath" init --bare
 [ $? -ne 0 ] && exit 1
 
 [ -f "$gitacls" ] && echo "Check $gitacls for proper access permissions"